;;;     VES.LSP - Written by Vetal
;;;
;;;     Copyright (C) 1999-2000 by Minskgrazhdanproekt.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun c:scal_v()
   (begin_v)
   (setq vet2 (mas_v))
   (end_v)
   (princ)
)


(defun c:scall_v()
   (begin_v)
   (setq vet1 (masl_v))
   (end_v)
   (princ)
)


(defun c:htext_v()
   (begin_v)
   (setq htxt_v (hitext_v))
   (end_v)
   (princ)
)


(defun hitext_v ( / hold a aa)
   (setq hold (cdr (assoc 40 (tblsearch "STYLE" (getvar "TEXTSTYLE")))))
   (if (zerop hold )
         (progn
           (if (= (getvar "USERR3") 0) (setvar "USERR3" (getvar "TEXTSIZE")))
           (setq a (rtos (getvar "USERR3") 2 2))
           (setq aa (getreal (strcat "\n  <" a ">: ")))
           (if (= aa nil) (setq aa (getvar "USERR3")))
           (setvar "USERR3" aa)
         )
         (setq aa hold)
   )
   aa
)


(defun masl_v ( / a aa)
   (if (= (getvar "USERR1") 0) (setvar "USERR1" 1.0))
   (setq a (rtos (getvar "USERR1") 2 1))
   (setq aa (getreal (strcat "\n  M<" a ">: ")))
   (if (= aa nil) (setq aa (getvar "USERR1")))
   (setvar "USERR1" aa)
   aa
)


(defun mas_v ( / a aa)
   (setq a (rtos (getvar "DIMLFAC") 2 2))
   (setq aa (getreal (strcat "\n M<" a ">: ")))
   (if (= aa nil) (setq aa (getvar "DIMLFAC")))
   (setvar "USERR2" aa)
   (setvar "DIMLFAC" aa)
   aa
)


(defun begin_v ()

   (setq cme_v (getvar "CMDECHO"))
   (setvar "CMDECHO"  0)
   (command "_.undo"  "_auto" "_off" \)
   (command "_.undo"  "_begin" \)                                                                              
   (setq blm_v (getvar "BLIPMODE"))
   (setq osm_v (getvar "OSMODE"))
   (setq plw_v (getvar "PLINEWID"))
   (setvar "BLIPMODE"  0)
   (setq older *error*)
   (setq *error* veer)
)


(defun end_v ()

   (setvar "BLIPMODE" blm_v)
   (setvar "OSMODE" osm_v)
   (setvar "PLINEWID" plw_v)

   (setq  *error* older)

   (command "_.undo"  "_end" \)
   (command "_.undo"  "_auto" "_on" \)
   (setvar "CMDECHO" cme_v)

)


(defun veer (msg)

  (if
    (or
       (wcmatch (strcase msg) "*EXIT*")
       (wcmatch (strcase msg) "*QUIT*")
       (wcmatch (strcase msg) "**")
       (wcmatch (strcase msg) "*CANCEL*")
       (wcmatch (strcase msg) "**")
       (wcmatch (strcase msg) "**")
    )
    (progn
       (if eend_v
       (progn
          (while (entnext eend_v)
             (entdel (entnext eend_v))
          )
          (end_v)
          (setvar "CMDECHO" 0)
          (setq eend_v nil)
          (command "_.undo"  "_end" \)
      )
      (progn
          (command "_.undo"  "_end" \)
          (command "_.u" \)
      ))
      (command "_.undo"  "_auto" "_on" \)
      (setvar "CMDECHO" cme_v)
      (if (/= vet1 (getvar "USERR1")) (setq vet1 (getvar "USERR1")))
      (if (/= vet2 (getvar "USERR2")) (setq vet2 (getvar "USERR2")))
      (if (/= htxt_v (getvar "USERR3")) (setq htxt_v (getvar "USERR3")))
    )
    (princ (strcat "\nError: " msg))
  )
  (princ)
)


(defun rc (pt aax aay)
   (list (+ (car pt)  (float aax)) (+ (cadr pt) (float aay)))
)


(defun dtr (a)
   (* pi (/ (float a) 180))
)


(defun rtd (a)
   (/ (* (float a) 180) pi)
)

(defun aa_v (a)
   (setq a (/ (float a) vet2))
)


(defun bb_v (b)
   (setq b (- 0 (/ (float b) vet2)))
)


(defun polar_v (pt ptt a b)
   (polar pt (dtr (+ (rtd (angle pt ptt)) a)) b)
)

(defun var_v (a / c b n i)

   (setq b T n (strlen a))
   (if (setq c (open (findfile "vecadvar.txt") "r"))
   (progn
    (while b
     (setq b (read-line c))
     (if (= (substr b 1 n) a)
      (setq i (read-line c) b nil))
    )
    (close c)
   ))
   (if (not i) (progn
    (princ (strcat "\n " a "  ."))
    (exit)
   )
   (progn
    (if (and (= (strcase i) "") (= a "lay")) (setq i (getvar "CLAYER")))
    (if (= (strcase i) "") (setq i (getvar "CECOLOR")))
    i
   ))
)

(defun pov_v (p1 p2 p3 / tt)
   (if (<= (- (angle p1 p2) (angle p1 p3)) 0)
    (if (< (abs (- (angle p1 p2) (angle p1 p3))) pi) (setq tt 1) (setq tt -1))
    (if (< (abs (- (angle p1 p2) (angle p1 p3))) pi) (setq tt -1) (setq tt 1))
   )
   (if (= (angle p1 p2) 0) (progn
   (if (> (cadr p3) (cadr p2)) (setq tt 1) (setq tt -1))))
tt
)

(defun vet_txt (pt b tt aa / hold)

     (setq hold (cdr (assoc 40 (tblsearch "STYLE" (getvar "TEXTSTYLE")))))
     (if (zerop hold)
        (cond
         ((= b "") (command "_.text" pt htxt_v aa tt \))
         ((= b "_f") (command "_.text" b pt aa htxt_v tt \))
         (T (command "_.text" b pt htxt_v aa tt \))
        )
        (cond
         ((= b "") (command "_.text"  pt aa tt \))
         ((= b "_f") (command "_.text" b pt aa  tt \))
         (T (command "_.text" b pt aa tt \))
        )
      )
)

(defun tlen_v (txt / d a b p1)
   (setq d (* (strlen txt) htxt_v))
   (setq p1 (rc (getvar "VIEWCTR") 0 (* 0.51 (getvar "VIEWSIZE"))))
   (vet_txt p1 "_f" txt (rc p1 d 0))
   (setq a (cdr (assoc 41 (entget (entlast)))))
   (setq b (cdr (assoc 41 (tblsearch "STYLE" (getvar "TEXTSTYLE")))))
   (entdel (entlast))
   (/ (* d b) a)
)

